<?

/*
    PHP Calendar Class Version 1.4 (5th March 2001)
    Copyright David Wilkinson 2000 - 2001. All Rights reserved.

    -- Changed by Philipp Lenssen, http://outer-court.com --

    This software may be used, modified and distributed freely
    providing this copyright notice remains intact at the head 
    of the file.

    This software is freeware. The author accepts no liability for
    any loss or damages whatsoever incurred directly or indirectly 
    from the use of this script. The author of this software makes 
    no claims as to its fitness for any purpose whatsoever. If you 
    wish to use this software you should first satisfy yourself that 
    it meets your requirements.

    URL:   http://www.cascade.org.uk/software/php/calendar/
    Email: davidw@cascade.org.uk
*/


class Calendar
{
    function Calendar()
    {
    }
    
    function getDayNames()
    {
        return $this->dayNames;
    }
    
    function setDayNames($names)
    {
        $this->dayNames = $names;
    }
    
    function getMonthNames()
    {
        return $this->monthNames;
    }
    
    function setMonthNames($names)
    {
        $this->monthNames = $names;
    }
    
      function getStartDay()
    {
        return $this->startDay;
    }
    
    function setStartDay($day)
    {
        $this->startDay = $day;
    }
    
    function getStartMonth()
    {
        return $this->startMonth;
    }
    
    function setStartMonth($month)
    {
        $this->startMonth = $month;
    }
    
    function getCalendarLink($month, $year)
    {
        return "";
    }
    
    function getDateLink($day, $month, $year)
    {
        return "calendar.php?mode=editDate&amp;day=" . $day . "&amp;month=" . $month . "&amp;year=" . $year;
    }

    function getCurrentMonthView()
    {
        $d = getdate(time());
        return $this->getMonthView($d["mon"], $d["year"]);
    }
    
    function getCurrentYearView()
    {
        $d = getdate(time());
        return $this->getYearView($d["year"]);
    }
    
    function getMonthHTML($month, $year)
    {
        return $this->getMonthHTML($month, $year);
    }
    
    function getYearView($year = "")
    {
        if ($year == "")
        {
            $d = getdate(time());
            $year = $d["year"];
        }

        return $this->getYearHTML($year);
    }
    
    /* __________________ Private mehods __________________ */
    
    function getDaysInMonth($month, $year)
    {
        if ($month < 1 || $month > 12)
        {
            return 0;
        }
   
        $d = $this->daysInMonth[$month - 1];
   
        if ($month == 2)
        {
            if ($year%4 == 0) // Check for leap year
            {
                if ($year%100 == 0)
                {
                    if ($year%400 == 0)
                    {
                        $d = 29;
                    }
                }
                else
                {
                    $d = 29;
                }
            }
        }
    
        return $d;
    }

    function getMonthHTML($m, $y, $showYear = 1)
    {
        $s = "";
        
        $a = $this->adjustDate($m, $y);
        $month = $a[0];
        $year = $a[1];        
        
        $daysInMonth = $this->getDaysInMonth($month, $year);
        $date = getdate(mktime(12, 0, 0, $month, 1, $year));
    	
        $first = $date["wday"];
        $monthName = $this->monthNames[$month - 1];
    	
        $header = $monthName . " <span class=\"monthMoreInfo\">". $year . "-" . pad($month) . "</span>";
    	
        $s .= "<table class=\"calendar\">\n";
        $s .= "<caption>$header</caption>\n"; 
    	
        $s .= "<tr>\n";
        for ($dayOffset = 0; $dayOffset <= 6; $dayOffset++)
        {
            if ($dayOffset == 0 || $dayOffset == 6)
            {
                $s .= "<th class=\"dateDayHeaderWeekend\" colspan=\"2\">";
            }
            else
            {
                $s .= "<th class=\"dateDayHeader\" colspan=\"2\">";
            }
            $s .= $this->dayNames[($this->startDay + $dayOffset)%7];
            $s .= "</th>\n";
        }
        $s .= "</tr>\n";
    	
        $d = $this->startDay + 1 - $first;
        while ($d > 1)
        {
            $d -= 7;
        }

        $today = getdate(time());
    	
        $sClass = "";
        while ($d <= $daysInMonth)
        {
            $s .= "<tr" . $sClass . ">\n";
    	    
            for ($i = 0; $i < 7; $i++)
            {
                if ($d > 0 && $d <= $daysInMonth)
                {
                    $text = "";
                    $fileName = "notes-" . $year . "-" . pad($month) . "-" . pad($d);
                    $filePath = "papers/" . $fileName . ".txt";
                    if ( file_exists($filePath) )
                    {
                        $text = getFileText($filePath);
                        $text = cutLength($text, 50);
                        $text = getXmlToText($text);
                        $text = str_replace("\r", "<br />", $text);
                        if ($this->sSearch != "")
                        {
                            $text = str_replace($this->sSearch,
                                    "<span class=\"found\">" . $this->sSearch . "</span>",
                                    $text);
                        }
                    }

                    $sIdDate = "";
                    $sIdText = "";
                    if ($year == $today["year"] && $month == $today["mon"] && $d == $today["mday"])
                    {
                        $sIdDate = " id=\"todayDate\"";
                        $sIdText = " id=\"todayText\"";
                    }

                    $s .= "<td" . $sIdDate . " class=\"dateDate\">";
                    $s .= "<a href=\"paper.php?path=" . $fileName . "\">" . $d . "</a>";
                    $s .= "</td>";

                    $s .= "<td" . $sIdText . " class=\"dateText\">" . $text . "</td>";
                }
                else
                {
                    $s .= "<td colspan=\"2\">&nbsp;</td>";
                }
                $d++;
                $sClass = ($sClass == "") ? " class=\"alternate\"" : "";
            }
            $s .= "</tr>\n";    
        }
    	
        $s .= "</table>\n";
    	
        return $s;  	
    }
    
    function getYearHTML($year)
    {
        $s = "";
        for ($j = 0; $j <= 11; $j++)
        {
            $s .= $this->getMonthHTML($j + $this->startMonth, $year, 0);
        }
        return $s;
    }

    function adjustDate($month, $year)
    {
        $a = array();  
        $a[0] = $month;
        $a[1] = $year;
        
        while ($a[0] > 12)
        {
            $a[0] -= 12;
            $a[1]++;
        }
        
        while ($a[0] <= 0)
        {
            $a[0] += 12;
            $a[1]--;
        }
        
        return $a;
    }

    var $startDay = 0;
    var $startMonth = 1;
    var $sSearch = "";
    var $dayNames = array("Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday");
    var $monthNames = array("January", "February", "March", "April", "May", "June",
            "July", "August", "September", "October", "November", "December");
    var $daysInMonth = array(31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
}

?>